routes/web.php
<?php

use App\Http\Controllers\Blog\BlogController;
use App\Http\Controllers\Globals\SubscribeController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/',[BlogController::class,'index'])
    ->name('index');

Route::post('subscribe', [SubscribeController::class,'store']);

Route::resource('blog', BlogController::class)
    ->only('show','index');

app/Models/Blog.php
<?php declare(strict_types=1);

namespace App\Models;

use App\Traits\UuidTrait;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\HasOne;

/**
 * @property mixed $uuid
 * @property string $title
 * @property string $description
 * @property mixed $activate
 * @property mixed $created_at
 * @property mixed $updated_at
 * @property integer $media
 * @property string $contents
 * @property mixed $lang
 * @method static create(array $array)
 */
class Blog extends Model
{
    use HasFactory, UuidTrait;

    private mixed $created_at;

    protected $hidden = ['id'];

    protected $fillable = [
        'uuid',
        'lang_id',
        'media_id',
        'category_id',
        'title',
        'description',
        'activate',
    ];


    public function media():BelongsTo
    {
        return $this->belongsTo(Media::class);
    }

    public function contents(): HasMany
    {
        return $this->hasMany(Content::class);
    }

    public function category(): BelongsTo
    {
        return $this->belongsTo(Category::class,'category_id','id');
    }

    public function lang(): HasOne
    {
        return $this->hasOne(Lang::class,'id','lang_id');
    }
}

app/Http/Controllers/Api/First/Blog/ApiBlogController.php
<?php declare(strict_types=1);

namespace App\Http\Controllers\Api\First\Blog;

use App\Http\Controllers\Controller;
use App\Http\Requests\Api\First\Blog\IndexRequest;
use App\Http\Resources\First\Blog\BlogResource;
use App\Services\Contracts\BlogServiceContract;
use Illuminate\Http\Resources\Json\AnonymousResourceCollection;

class ApiBlogController extends Controller
{
    public function __construct(
        private BlogServiceContract $blog
    )
    {
        //
    }

    public function index(IndexRequest $request): AnonymousResourceCollection
    {
        $request->validated();
        return BlogResource::collection(
            $this->blog->getBlogs(
                $request->perPage ? (int) $request->perPage : null
            )
        );
    }
}

app/Http/Controllers/Blog/BlogController.php
<?php

namespace App\Http\Controllers\Blog;

use App\Http\Controllers\Controller;
use App\Models\Blog;
use App\Services\Contracts\BlogServiceContract;
use App\Services\Contracts\CategoryServiceContract;
use Illuminate\Contracts\View\View;
use function view;

class BlogController extends Controller
{
    public function __construct(
        private CategoryServiceContract $category,
        private BlogServiceContract $blog
    ){
        //
    }


    public function index(): View
    {
        return view('blog.index',[
            'blog' => true,
            'categories' => $this->category->categoryBlog(),
            'blog_posts' => $this->blog->getBlogs(),
        ]);
    }


    public function show(Blog $blog): View
    {
        return view('blog.pages.product',
            ['blog' => $blog]
        );
    }
}

resources/views/blog/index.blade.php
@extends('blog.layouts.app')
@section('content')
    <!-- Navbar -->
    <!-- navbar -->
    <div id="app">
        <div class="vg-page page-blog">
            <div class="container">
                <div class="row widget-grid">
                    <div class="col-lg-8"></div>
                    <div class="col-lg-4">
                        <div class="d-flex py-2 mx-n2">
                            <div class="input-group px-2">
                                <select id="l_category" class="vg-select">
                                    <option value="">{{ __('portfolio.category') }}</option>
                                    @foreach($categories as $category)
                                        <option
                                            value="{{ $category->filter }}">{{ __('portfolio.' .$category->name) }}</option>
                                    @endforeach
                                </select>
                            </div>
                            <div class="input-group px-2">
                                <select id="l_sort" class="vg-select">
                                    <option value="">{{ __('portfolio.sort_by') }}</option>
                                    <option value="cat-1">....</option>
                                </select>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row post-grid">
                    @foreach($blog_posts as $post)
                        <div class="col-md-6 col-lg-4">
                            <div class="card">
                                <div class="img-place">
                                    <img src="{{ asset('/img/'.$post->media->fullPath) }}"
                                         alt="{{ $post->media->alt }}">
                                </div>
                                <div class="caption">
                                    <a href="javascript:void(0)" class="post-category">{{ $post->title }}</a>
                                    <a href="{{ route('blog.show',[$post]) }}" class="post-title">{{ $post->description }}</a>
                                    <span class="post-date"><span
                                            class="sr-only">{{ __('portfolio.published') }}</span> {{ $post->created_at->format('d M Y') }}</span>
                                </div>
                            </div>
                        </div>
                    @endforeach
                    <div class="col-12 py-3">
                        <div class="text-center m-3">
                            <p class="post-date">  {{ __('portfolio.page') . $blog_posts->currentPage() . __('portfolio.of') . $blog_posts->lastPage() }}</p>
                        </div>
                        @if ($blog_posts->hasPages())
                            <ul class="pagination justify-content-center">
                                @if ($blog_posts->onFirstPage())
                                    <li class="page-item disabled">
                                        <a href="{{ $blog_posts->previousPageUrl() }}"
                                           class="page-link" rel="prev">{{ __('Prev') }}</a>
                                    </li>
                                @else
                                    <li class="page-item">
                                        <a href="{{ $blog_posts->previousPageUrl() }}"
                                           class="page-link" rel="prev">{{ __('Prev') }}</a></li>
                                @endif
                                @if ($blog_posts->hasMorePages())
                                    <li class="page-item active">
                                        <a class="page-link"
                                           href="{{ $blog_posts->nextPageUrl() }}"
                                           rel="next">{{ __('Next') }}</a></li>
                                @else
                                    <li class="page-item disabled">
                                        <a href="" class="page-link" rel="prev">{{ __('Next') }}</a>
                                    </li>
                                @endif
                            </ul>
                        @endif
                    </div>
                    <x-globals.subscribe-component></x-globals.subscribe-component>
                </div>
            </div>
        </div>
    </div>
    <label for="l_search"></label>
    <label for="l_category"></label>
    <label for="l_sort"></label>
@endsection